#include <math.h>
#define MAX_EQNS 20
#define G (-9.800)
#define MSIZE 4
#define MASS2 10.000000
#define INER2 0.833300
#define LENCM2 0.500000
#define A_CM2 0.000000
#define LENAT2 1.000000
#define A_AT2 0.000000
#define MASS1 10.000000
#define INER1 0.833300
#define LENCM1 0.500000
#define A_CM1 0.000000
#define LENAT1 0.000000
#define A_AT1 0.000000

dyn_twolink(st,t,Fext,ac)
float *st,*t,*Fext,*ac;
{
	float A[MAX_EQNS][MAX_EQNS],b[MAX_EQNS],x[MAX_EQNS];
	float th1;
	float dth1;
	float cm_angle1;
	float sin_cm1;
	float cos_cm1;
	float th2;
	float dth2;
	float cm_angle2;
	float sin_cm2;
	float cos_cm2;
	float at_angle2;
	float sin_at2;
	float cos_at2;
	float k[34];

	th1 = 		 st[4];
	dth1 = 		 st[5];
	cm_angle1 = 		 A_CM1
		+th1;
	sin_cm1 = 		 sin(cm_angle1);
	cos_cm1 = 		 cos(cm_angle1);
	th2 = 		 th1
		+st[6];
	dth2 = 		 dth1
		+st[7];
	cm_angle2 = 		 A_CM2
		+th2;
	sin_cm2 = 		 sin(cm_angle2);
	cos_cm2 = 		 cos(cm_angle2);
	at_angle2 = 		 A_AT2
		+th1;
	sin_at2 = 		 sin(at_angle2);
	cos_at2 = 		 cos(at_angle2);
	k[0] = 		-dth1*dth1*LENCM1*cos_cm1;
	k[1] = 		-sin_cm1*LENCM1;
	k[2] = 		-dth1*dth1*LENCM1*sin_cm1;
	k[3] = 		 cos_cm1*LENCM1;
	k[4] = 		-dth1*dth1*LENAT2*cos_at2;
	k[5] = 		-sin_at2*LENAT2;
	k[6] = 		-dth1*dth1*LENAT2*sin_at2;
	k[7] = 		 cos_at2*LENAT2;
	k[8] = 		-dth2*dth2*LENCM2*cos_cm2;
	k[9] = 		-sin_cm2*LENCM2;
	k[10] = 		-sin_cm2*LENCM2;
	k[11] = 		-dth2*dth2*LENCM2*sin_cm2;
	k[12] = 		 cos_cm2*LENCM2;
	k[13] = 		 cos_cm2*LENCM2;
	k[14] = 		-MASS2*G;
	k[15] = 		-MASS1*G;
	k[16] = 		 MASS2*G*LENCM2*cos_cm2
		+t[1];
	k[17] = 		-MASS2*LENCM2*cos_cm2;
	k[18] = 		 MASS2*LENCM2*sin_cm2;
	k[19] = 		 MASS1*G*LENCM1*cos_cm1
		+t[0]
		-t[1];
	k[20] = 		-LENAT2*cos_at2;
	k[21] = 		 LENAT2*sin_at2;
	k[22] = 		-MASS1*LENCM1*cos_cm1;
	k[23] = 		 MASS1*LENCM1*sin_cm1;
	k[24] = 		 k[5]
		+k[10];
	k[25] = 		 k[4]
		+k[8];
	k[26] = 		 MASS2*k[9];
	k[27] = 		 MASS2*k[24];
	k[28] = 		 MASS2*k[25];
	k[29] = 		 k[7]
		+k[13];
	k[30] = 		 k[6]
		+k[11];
	k[31] = 		 MASS2*k[12];
	k[32] = 		 MASS2*k[29];
	k[33] = 		 MASS2*k[30]
		+k[14];

	A[0][0] = 		 MASS1
		+MASS2;
	A[0][1] = 		0;
	A[0][2] = 		 k[26];
	A[0][3] = 		 MASS1*k[1]
		+k[27];
	A[1][0] = 		0;
	A[1][1] = 		 MASS1
		+MASS2;
	A[1][2] = 		 k[31];
	A[1][3] = 		 MASS1*k[3]
		+k[32];
	A[2][0] = 		 k[18];
	A[2][1] = 		 k[17];
	A[2][2] = 		 k[18]*k[9]
		+k[17]*k[12]
		-INER2;
	A[2][3] = 		 k[18]*k[24]
		+k[17]*k[29]
		-INER2;
	A[3][0] = 		 k[23]
		+k[21]*MASS2;
	A[3][1] = 		 k[22]
		+k[20]*MASS2;
	A[3][2] = 		 k[21]*k[26]
		+k[20]*k[31];
	A[3][3] = 		 k[23]*k[1]
		+k[22]*k[3]
		+k[21]*k[27]
		+k[20]*k[32]
		-INER1;
	b[0] = 		-MASS1*k[0]
		-k[28];
	b[1] = 		-MASS1*k[2]
		-k[15]
		-k[33];
	b[2] = 		-k[18]*k[25]
		-k[17]*k[30]
		-k[16];
	b[3] = 		-k[23]*k[0]
		-k[22]*k[2]
		-k[19]
		-k[21]*k[28]
		-k[20]*k[33];
	lin_eq_solv(A,b,x,4);
	ac[0] = x[0];
	ac[1] = x[1];
	ac[3] = x[2];
	ac[2] = x[3];
}

mon_twolink(state,mstate)
float *state,*mstate;
{

}

