#include <math.h>
#define MAX_EQNS 20
#define G (-9.800)
#define MSIZE 5
#define MASS3 0.300000
#define INER3 0.000625
#define LENCM3 0.104403
#define A_CM3 -0.291457
#define LENMON6 0.151327
#define A_M6 0.132552
#define LENMON5 0.194165
#define A_M5 -0.207496
#define LENMON4 0.117047
#define A_M4 -0.348771
#define LENMON3 0.000000
#define A_M3 0.000000
#define LENAT3 0.150000
#define A_AT3 3.141593
#define MASS2 0.100000
#define INER2 0.000191
#define LENCM2 0.075000
#define A_CM2 3.141593
#define LENAT2 0.020000
#define A_AT2 1.570796
#define MASS1 0.150000
#define INER1 0.000170
#define LENCM1 0.000000
#define A_CM1 0.000000
#define LENMON2 0.100000
#define A_M2 0.000000
#define LENMON1 0.100000
#define A_M1 3.141593
#define LENAT1 0.000000
#define A_AT1 0.000000

dyn_luxo(st,t,Fext,ac)
float *st,*t,*Fext,*ac;
{
	float A[MAX_EQNS][MAX_EQNS],b[MAX_EQNS],x[MAX_EQNS];
	float th1;
	float dth1;
	float cm_angle1;
	float sin_cm1;
	float cos_cm1;
	float m_angle2;
	float sin_m2;
	float cos_m2;
	float m_angle1;
	float sin_m1;
	float cos_m1;
	float th2;
	float dth2;
	float cm_angle2;
	float sin_cm2;
	float cos_cm2;
	float at_angle2;
	float sin_at2;
	float cos_at2;
	float th3;
	float dth3;
	float cm_angle3;
	float sin_cm3;
	float cos_cm3;
	float at_angle3;
	float sin_at3;
	float cos_at3;
	float m_angle6;
	float sin_m6;
	float cos_m6;
	float m_angle5;
	float sin_m5;
	float cos_m5;
	float m_angle4;
	float sin_m4;
	float cos_m4;
	float m_angle3;
	float sin_m3;
	float cos_m3;
	float k[76];

	th1 = 		 st[4];
	dth1 = 		 st[5];
	cm_angle1 = 		 A_CM1
		+th1;
	sin_cm1 = 		 sin(cm_angle1);
	cos_cm1 = 		 cos(cm_angle1);
	m_angle2 = 		 A_M2
		+th1;
	sin_m2 = 		 sin(m_angle2);
	cos_m2 = 		 cos(m_angle2);
	m_angle1 = 		 A_M1
		+th1;
	sin_m1 = 		 sin(m_angle1);
	cos_m1 = 		 cos(m_angle1);
	th2 = 		 th1
		+st[6];
	dth2 = 		 dth1
		+st[7];
	cm_angle2 = 		 A_CM2
		+th2;
	sin_cm2 = 		 sin(cm_angle2);
	cos_cm2 = 		 cos(cm_angle2);
	at_angle2 = 		 A_AT2
		+th1;
	sin_at2 = 		 sin(at_angle2);
	cos_at2 = 		 cos(at_angle2);
	th3 = 		 th2
		+st[8];
	dth3 = 		 dth2
		+st[9];
	cm_angle3 = 		 A_CM3
		+th3;
	sin_cm3 = 		 sin(cm_angle3);
	cos_cm3 = 		 cos(cm_angle3);
	at_angle3 = 		 A_AT3
		+th2;
	sin_at3 = 		 sin(at_angle3);
	cos_at3 = 		 cos(at_angle3);
	m_angle6 = 		 A_M6
		+th3;
	sin_m6 = 		 sin(m_angle6);
	cos_m6 = 		 cos(m_angle6);
	m_angle5 = 		 A_M5
		+th3;
	sin_m5 = 		 sin(m_angle5);
	cos_m5 = 		 cos(m_angle5);
	m_angle4 = 		 A_M4
		+th3;
	sin_m4 = 		 sin(m_angle4);
	cos_m4 = 		 cos(m_angle4);
	m_angle3 = 		 A_M3
		+th3;
	sin_m3 = 		 sin(m_angle3);
	cos_m3 = 		 cos(m_angle3);
	k[0] = 		-dth1*dth1*LENCM1*cos_cm1;
	k[1] = 		-sin_cm1*LENCM1;
	k[2] = 		-dth1*dth1*LENCM1*sin_cm1;
	k[3] = 		 cos_cm1*LENCM1;
	k[4] = 		-dth1*dth1*LENAT2*cos_at2;
	k[5] = 		-sin_at2*LENAT2;
	k[6] = 		-dth1*dth1*LENAT2*sin_at2;
	k[7] = 		 cos_at2*LENAT2;
	k[8] = 		-dth2*dth2*LENCM2*cos_cm2;
	k[9] = 		-sin_cm2*LENCM2;
	k[10] = 		-sin_cm2*LENCM2;
	k[11] = 		-dth2*dth2*LENCM2*sin_cm2;
	k[12] = 		 cos_cm2*LENCM2;
	k[13] = 		 cos_cm2*LENCM2;
	k[14] = 		-dth2*dth2*LENAT3*cos_at3;
	k[15] = 		-sin_at3*LENAT3;
	k[16] = 		-sin_at3*LENAT3;
	k[17] = 		-dth2*dth2*LENAT3*sin_at3;
	k[18] = 		 cos_at3*LENAT3;
	k[19] = 		 cos_at3*LENAT3;
	k[20] = 		-dth3*dth3*LENCM3*cos_cm3;
	k[21] = 		-sin_cm3*LENCM3;
	k[22] = 		-sin_cm3*LENCM3;
	k[23] = 		-sin_cm3*LENCM3;
	k[24] = 		-dth3*dth3*LENCM3*sin_cm3;
	k[25] = 		 cos_cm3*LENCM3;
	k[26] = 		 cos_cm3*LENCM3;
	k[27] = 		 cos_cm3*LENCM3;
	k[28] = 		-Fext[10]
		-Fext[8]
		-Fext[6]
		-Fext[4];
	k[29] = 		-Fext[11]
		-Fext[9]
		-Fext[7]
		-Fext[5]
		-MASS3*G;
	k[30] = 		-MASS2*G;
	k[31] = 		-Fext[2]
		-Fext[0];
	k[32] = 		-Fext[3]
		-Fext[1]
		-MASS1*G;
	k[33] = 		 MASS3*G*LENCM3*cos_cm3
		+t[2]
		-Fext[10]*LENMON6*sin_m6
		+Fext[11]*LENMON6*cos_m6
		-Fext[8]*LENMON5*sin_m5
		+Fext[9]*LENMON5*cos_m5
		-Fext[6]*LENMON4*sin_m4
		+Fext[7]*LENMON4*cos_m4
		-Fext[4]*LENMON3*sin_m3
		+Fext[5]*LENMON3*cos_m3;
	k[34] = 		-MASS3*LENCM3*cos_cm3;
	k[35] = 		 MASS3*LENCM3*sin_cm3;
	k[36] = 		 MASS2*G*LENCM2*cos_cm2
		+t[1]
		-t[2];
	k[37] = 		-LENAT3*cos_at3;
	k[38] = 		 LENAT3*sin_at3;
	k[39] = 		-MASS2*LENCM2*cos_cm2;
	k[40] = 		 MASS2*LENCM2*sin_cm2;
	k[41] = 		 MASS1*G*LENCM1*cos_cm1
		+t[0]
		-t[1]
		-Fext[2]*LENMON2*sin_m2
		+Fext[3]*LENMON2*cos_m2
		-Fext[0]*LENMON1*sin_m1
		+Fext[1]*LENMON1*cos_m1;
	k[42] = 		-LENAT2*cos_at2;
	k[43] = 		 LENAT2*sin_at2;
	k[44] = 		-MASS1*LENCM1*cos_cm1;
	k[45] = 		 MASS1*LENCM1*sin_cm1;
	k[46] = 		 k[5]
		+k[16];
	k[47] = 		 k[4]
		+k[14];
	k[48] = 		 k[15]
		+k[22];
	k[49] = 		 k[46]
		+k[23];
	k[50] = 		 k[47]
		+k[20];
	k[51] = 		 MASS3*k[21];
	k[52] = 		 MASS3*k[48];
	k[53] = 		 MASS3*k[49];
	k[54] = 		 MASS3*k[50]
		+k[28];
	k[55] = 		 k[5]
		+k[10];
	k[56] = 		 k[4]
		+k[8];
	k[57] = 		 MASS2
		+MASS3;
	k[58] = 		 MASS2*k[9]
		+k[52];
	k[59] = 		 MASS2*k[55]
		+k[53];
	k[60] = 		 MASS2*k[56]
		+k[54];
	k[61] = 		 k[7]
		+k[19];
	k[62] = 		 k[6]
		+k[17];
	k[63] = 		 k[18]
		+k[26];
	k[64] = 		 k[61]
		+k[27];
	k[65] = 		 k[62]
		+k[24];
	k[66] = 		 MASS3*k[25];
	k[67] = 		 MASS3*k[63];
	k[68] = 		 MASS3*k[64];
	k[69] = 		 MASS3*k[65]
		+k[29];
	k[70] = 		 k[7]
		+k[13];
	k[71] = 		 k[6]
		+k[11];
	k[72] = 		 MASS2
		+MASS3;
	k[73] = 		 MASS2*k[12]
		+k[67];
	k[74] = 		 MASS2*k[70]
		+k[68];
	k[75] = 		 MASS2*k[71]
		+k[30]
		+k[69];

	A[0][0] = 		 MASS1
		+k[57];
	A[0][1] = 		0;
	A[0][2] = 		 k[51];
	A[0][3] = 		 k[58];
	A[0][4] = 		 MASS1*k[1]
		+k[59];
	A[1][0] = 		0;
	A[1][1] = 		 MASS1
		+k[72];
	A[1][2] = 		 k[66];
	A[1][3] = 		 k[73];
	A[1][4] = 		 MASS1*k[3]
		+k[74];
	A[2][0] = 		 k[35];
	A[2][1] = 		 k[34];
	A[2][2] = 		 k[35]*k[21]
		+k[34]*k[25]
		-INER3;
	A[2][3] = 		 k[35]*k[48]
		+k[34]*k[63]
		-INER3;
	A[2][4] = 		 k[35]*k[49]
		+k[34]*k[64]
		-INER3;
	A[3][0] = 		 k[40]
		+k[38]*MASS3;
	A[3][1] = 		 k[39]
		+k[37]*MASS3;
	A[3][2] = 		 k[38]*k[51]
		+k[37]*k[66];
	A[3][3] = 		 k[40]*k[9]
		+k[39]*k[12]
		+k[38]*k[52]
		+k[37]*k[67]
		-INER2;
	A[3][4] = 		 k[40]*k[55]
		+k[39]*k[70]
		+k[38]*k[53]
		+k[37]*k[68]
		-INER2;
	A[4][0] = 		 k[45]
		+k[43]*k[57];
	A[4][1] = 		 k[44]
		+k[42]*k[72];
	A[4][2] = 		 k[43]*k[51]
		+k[42]*k[66];
	A[4][3] = 		 k[43]*k[58]
		+k[42]*k[73];
	A[4][4] = 		 k[45]*k[1]
		+k[44]*k[3]
		+k[43]*k[59]
		+k[42]*k[74]
		-INER1;
	b[0] = 		-MASS1*k[0]
		-k[31]
		-k[60];
	b[1] = 		-MASS1*k[2]
		-k[32]
		-k[75];
	b[2] = 		-k[35]*k[50]
		-k[34]*k[65]
		-k[33];
	b[3] = 		-k[40]*k[56]
		-k[39]*k[71]
		-k[36]
		-k[38]*k[54]
		-k[37]*k[69];
	b[4] = 		-k[45]*k[0]
		-k[44]*k[2]
		-k[43]*k[60]
		-k[42]*k[75]
		-k[41];
	lin_eq_solv(A,b,x,5);
	ac[0] = x[0];
	ac[1] = x[1];
	ac[4] = x[2];
	ac[3] = x[3];
	ac[2] = x[4];
}

mon_luxo(state,mstate)
float *state,*mstate;
{
	float th1;
	float dth1;
	float xo1;
	float yo1;
	float vxo1;
	float vyo1;
	float m_angle2;
	float sin_m2;
	float cos_m2;
	float m_angle1;
	float sin_m1;
	float cos_m1;
	float th2;
	float dth2;
	float at_angle2;
	float sin_at2;
	float cos_at2;
	float xo2;
	float yo2;
	float vxo2;
	float vyo2;
	float th3;
	float dth3;
	float at_angle3;
	float sin_at3;
	float cos_at3;
	float xo3;
	float yo3;
	float vxo3;
	float vyo3;
	float m_angle6;
	float sin_m6;
	float cos_m6;
	float m_angle5;
	float sin_m5;
	float cos_m5;
	float m_angle4;
	float sin_m4;
	float cos_m4;
	float m_angle3;
	float sin_m3;
	float cos_m3;

	th1 = 		 state[4];
	dth1 = 		 state[5];
	xo1 = 		 state[0];
	yo1 = 		 state[2];
	vxo1 = 		 state[1];
	vyo1 = 		 state[3];
	m_angle2 = 		 A_M2
		+th1;
	sin_m2 = 		 sin(m_angle2);
	cos_m2 = 		 cos(m_angle2);
	mstate[4] = 		 LENMON2*cos_m2
		+xo1;
	mstate[6] = 		 LENMON2*sin_m2
		+yo1;
	mstate[5] = 		-LENMON2*sin_m2*dth1
		+vxo1;
	mstate[7] = 		 LENMON2*cos_m2*dth1
		+vyo1;
	m_angle1 = 		 A_M1
		+th1;
	sin_m1 = 		 sin(m_angle1);
	cos_m1 = 		 cos(m_angle1);
	mstate[0] = 		 LENMON1*cos_m1
		+xo1;
	mstate[2] = 		 LENMON1*sin_m1
		+yo1;
	mstate[1] = 		-LENMON1*sin_m1*dth1
		+vxo1;
	mstate[3] = 		 LENMON1*cos_m1*dth1
		+vyo1;
	th2 = 		 th1
		+state[6];
	dth2 = 		 dth1
		+state[7];
	at_angle2 = 		 A_AT2
		+th1;
	sin_at2 = 		 sin(at_angle2);
	cos_at2 = 		 cos(at_angle2);
	xo2 = 		 LENAT2*cos_at2
		+xo1;
	yo2 = 		 LENAT2*sin_at2
		+yo1;
	vxo2 = 		-LENAT2*sin_at2*dth1
		+vxo1;
	vyo2 = 		 LENAT2*cos_at2*dth1
		+vyo1;
	th3 = 		 th2
		+state[8];
	dth3 = 		 dth2
		+state[9];
	at_angle3 = 		 A_AT3
		+th2;
	sin_at3 = 		 sin(at_angle3);
	cos_at3 = 		 cos(at_angle3);
	xo3 = 		 LENAT3*cos_at3
		+xo2;
	yo3 = 		 LENAT3*sin_at3
		+yo2;
	vxo3 = 		-LENAT3*sin_at3*dth2
		+vxo2;
	vyo3 = 		 LENAT3*cos_at3*dth2
		+vyo2;
	m_angle6 = 		 A_M6
		+th3;
	sin_m6 = 		 sin(m_angle6);
	cos_m6 = 		 cos(m_angle6);
	mstate[20] = 		 LENMON6*cos_m6
		+xo3;
	mstate[22] = 		 LENMON6*sin_m6
		+yo3;
	mstate[21] = 		-LENMON6*sin_m6*dth3
		+vxo3;
	mstate[23] = 		 LENMON6*cos_m6*dth3
		+vyo3;
	m_angle5 = 		 A_M5
		+th3;
	sin_m5 = 		 sin(m_angle5);
	cos_m5 = 		 cos(m_angle5);
	mstate[16] = 		 LENMON5*cos_m5
		+xo3;
	mstate[18] = 		 LENMON5*sin_m5
		+yo3;
	mstate[17] = 		-LENMON5*sin_m5*dth3
		+vxo3;
	mstate[19] = 		 LENMON5*cos_m5*dth3
		+vyo3;
	m_angle4 = 		 A_M4
		+th3;
	sin_m4 = 		 sin(m_angle4);
	cos_m4 = 		 cos(m_angle4);
	mstate[12] = 		 LENMON4*cos_m4
		+xo3;
	mstate[14] = 		 LENMON4*sin_m4
		+yo3;
	mstate[13] = 		-LENMON4*sin_m4*dth3
		+vxo3;
	mstate[15] = 		 LENMON4*cos_m4*dth3
		+vyo3;
	m_angle3 = 		 A_M3
		+th3;
	sin_m3 = 		 sin(m_angle3);
	cos_m3 = 		 cos(m_angle3);
	mstate[8] = 		 LENMON3*cos_m3
		+xo3;
	mstate[10] = 		 LENMON3*sin_m3
		+yo3;
	mstate[9] = 		-LENMON3*sin_m3*dth3
		+vxo3;
	mstate[11] = 		 LENMON3*cos_m3*dth3
		+vyo3;
}

