/************************************************************
	FILE: main.c

************************************************************/

#define MAIN
#include "defs.h"
#include "globals.h"

/************************************************************
	PROC:	main
	DOES:	initializes globals
************************************************************/

main(argc,argv)
int argc;
char **argv;
{
	init();			/* initialize globals */
	if ((argc==2) && (!strcmp(argv[1],"-f")))
		IMode = FALSE;
	else
		title();		/* print title banner */
	interp(stdin);	/* interpret commands from stdin */
}

/************************************************************
	PROC:	init
	DOES:	initializes globals
************************************************************/

init()
{
	DEbug = FALSE;
	strcpy(DIspfile,"sim.out");
	DTdisp = 0.02;
	DTsim = 0.01;
	Mon = (PFI) NULL;
	Dyn = (PFI)  NULL;
	strcpy(HElpfile,HELPFILE);
	strcpy(DIrname,".");
	IMode = TRUE;
	KDamp[0] = 0.01;
	STate_size = 0;
}

/************************************************************
	PROC:	title()
	DOES:	prints title banner
************************************************************/

title()
{
	printf("\n\tPROGRAM SHELL\n");
	printf("Type 'help <topic>' for online help\n\n");
}
