/************************************************************
	FILE: shell.c

************************************************************/

#include "defs.h"
#include "globals.h"

/************************************************************
	PROC:	cerr
	DOES:	handles command errors
************************************************************/

cerr(argc,argv,errmsg)
int argc;
STR argv[];
char *errmsg;
{
	int n;

	fprintf(stderr,"ERROR in line %d: %s\n",Linenum,errmsg);
	fprintf(stderr,"===> ");
	for (n=0; n<argc; n++) fprintf(stderr,"%s ",argv[n]);
	fprintf(stderr,"\n");
}

/************************************************************
	PROC:	readline
	INPUT:	args array
	DOES:	reads in command line, parses, places results in args
************************************************************/

readline(file,argc,argv)
FILE	*file;
int	*argc;
STR	argv[];
{
	STR	line;

	fgets(line,STRLEN,file);
	if (feof(file)) {
		*argc = 0;
		return;
	}
	parse(line," \t\n",argc,argv);
}
	
/************************************************************
	PROC:	parse
	INPUT:	string, parselist, argc, argv
	DOES:	parses items in a string, places results in args
************************************************************/

parse(line,parselist,argc,argv)
STR line,parselist;
int	*argc;
STR	argv[];
{
	int	indx=0;
	int	copying = 0;
	int	narg=0;
	int	argch=0;
	char	ch;

	while (line[indx]) {
		ch = line[indx++];
		if (ch=='#') break;
		if ( strchr(parselist,ch)) {
			if (copying) {
				copying=0;
				argv[narg][argch]=0;
				narg++;
				argch=0;
			}
		} else {
			if (!copying) copying=1;
			argv[narg][argch++] = ch;
		}
	}
	if (copying) {
		argv[narg][argch] = 0;
		*argc = ++narg;
	} else *argc = narg;
}
