/************************************************************
	FILE: globals.h
	-contains all globals for shell
	Michiel van de Panne, University of Toronto
************************************************************/

#ifdef MAIN
#define extern
#endif

	/* vars accessible through set */
extern BOOL DEbug;
extern STR HElpfile;
extern STR DIrname;
extern STR FIlename;
extern BOOL IMode;
extern BOOL INverse;
extern float GRavity;
extern BOOL ROotmon;        // root monitor points only
extern STR PRocname;		/* procedure name */
extern float TEstfloat;
extern STR TEststring;
extern FVEC TEstfvec;
extern IVEC TEstivec;
extern int TEstint;
extern BOOL TEstflag;

	/* others */
extern EQNSET Const_eqns;	/* constant equations */
extern TERM *Eqns[MAX_EQNS];
extern TERM *Eqmat[MAX_EQNS][MAX_EQNS];	/* pointers to terms */
extern TERM *Eqconst[MAX_EQNS];	/* constant terms for equations */
extern STR  Err;			/* string used for err messages */
extern int  Flinks;			/* number of fixed links */
extern int  Kcount;
extern STR  Label[MAX_LINKS*3];	/* equation labels */
extern int  Linenum;		/* line # of input */
extern LINK	*Link;			/* head link of linked list */
extern int	Msize;			/* matrix size */
extern int  Nlinks;			/* number of links */
extern EQNSET Ptr_eqns;		/* a list of reduced equations */
extern LINK *Rlink;			/* pointer to root link */
extern int	Rt;				/* link number of root link */
extern STR  Var[MAX_LINKS*3];	/* unknowns */
extern BOOL Verbose;		/* spews out info if set */

#ifdef MAIN
#undef extern
#endif
