////////////////////////////////////////////
//	FILE: main.cpp
//
////////////////////////////////////////////

#define MAIN
#include "defs.h"
#include "globals.h"

void init();
void title();

/************************************************************
	PROC:	main
	DOES:	initializes globals
************************************************************/

main(int argc, char **argv)
{
	init();			/* initialize globals */
	if (argc==2) {
		IMode = FALSE;
		FILE *fp = fopen(argv[1],"rt");
		if (fp)
			interp(fp);
	}
	else {
		title();		/* print title banner */
		interp(stdin);	/* interpret commands from stdin */
	}
	return 0;
}

/************************************************************
	PROC:	init
	DOES:	initializes globals
************************************************************/

void init()
{
	DEbug = FALSE;
	FIlename[0] = 0;
	strcpy(HElpfile,"help.txt");
	IMode = TRUE;
	INverse = FALSE;
	ROotmon = FALSE;
	Kcount = 0;
	GRavity = -9.8f;
	Linenum = 0;
	Link = (LINK *) NULL;
	strcpy(PRocname,"dyn");
	Ptr_eqns.num_eqns = 0;
	Rt = 0;
	Verbose = TRUE;
}

/************************************************************
	PROC:	title()
	DOES:	prints title banner
************************************************************/

void title()
{
	printf("\n\tDYNCOMP: Dynamics Compiler\n");
	printf("Type 'help <topic>' for online help\n\n");
}
   
